/*
BDETECT CALLBACK TO ADD TO EACH UNIT'S LOCAL BULLET COUNT AND SUPPRESSION STATUS 
- called/spawned from bDetect
- increments a unit's enemy and total bullet count
- assigns supression status based on these bullet counts
- minimal calculation, to keep it fast
*/

tpwcas_fnc_supstate =  
	{ 
	private [ "_unit","_data","_shooter","_shooterside","_bulletcount","_enemybulletcount"]; 

	_unit = _this select 0; //suppressed unit 
	_data = _this select 3; //bullet data 
	_shooter = _data select 0; //shooter 
	_shooterside = side _shooter; //side of shooter 

	_bulletcount = _unit getvariable "tpwcas_bulletcount"; //total bullet count 
	_enemybulletcount = _unit getvariable "tpwcas_enemybulletcount"; //enemy bullet count 
	_bulletcount = _bulletcount + 1; 
	_unit setvariable ["tpwcas_skillregain", time + 2 + random 3];        
	_unit setvariable ["tpwcas_stanceregain", time + 8 + random 5];   
	_unit setvariable ["tpwcas_bulletcount", _bulletcount]; 
	_unit setvariable ["tpwcas_supstate",1]; 

	if (_shooterside getFriend ( side _unit) < 0.6 ) then  
		{ 
		_enemybulletcount = _enemybulletcount + 1; 
		_unit setvariable ["tpwcas_enemybulletcount", _enemybulletcount]; 
		if (tpwcas_reveal > 0) then 
			{
			_unit reveal [_shooter, tpwcas_reveal]; 
			};
		}; 

	if (_enemybulletcount > 0) then  
		{ 
		_unit setvariable ["tpwcas_supstate",2]; 
		}; 

	if (_enemybulletcount > tpwcas_st) then  
		{ 
		_unit setvariable ["tpwcas_supstate",3]; 
		}; 
	};  
