/*
FLOATING TEXT BASED DEBUG
- Called per unit from main loop:
- Displays appropriate coloured floating debug text depending on unit's suppression state
- Hides text for unsuppressed or injured units
*/

tpwcas_fnc_textdebug =
	{
	private ["_unit","_rate","_display","_control","_pos2d","_sup","_disp","_text"];
	_unit = _this select 0;
	_rate = _this select 1;
	disableserialization;

	if (isnil "BIS_fnc_3dCredits_n") then {BIS_fnc_3dCredits_n = 2733;};
	BIS_fnc_3dCredits_n cutrsc ["rscDynamicText","plain"];
	BIS_fnc_3dCredits_n = BIS_fnc_3dCredits_n + 1;
	_display = uinamespace getvariable "BIS_dynamicText";
	_control = _display displayctrl 9999;
	while {true} do 
		{
		_pos2d = worldtoscreen getposatl _unit;
		if (count _pos2D > 0) then 
			{
			_sup = _unit getvariable "tpwcas_supstate";
			_disp = _unit getvariable "tpwcas_enemybulletcount";
			_text = "";
			switch ( true ) do
				{
				case (lifestate _unit != "ALIVE"): {_text = ""};
				case (fleeing _unit): {_text = format ["<t color ='#000000' shadow ='0' size='0.35'>%1</t>",_disp]};
				case (_sup == 0): {_text = format ["<t color ='#66ffffff' shadow ='0' size='0.35'>%1</t>",_disp]}; 
				case (_sup == 1): {_text = format ["<t color ='#6600ff00' shadow ='0' size='0.35'>%1</t>",_disp]};
				case (_sup == 2): {_text = format ["<t color ='#66ffff00' shadow ='0' size='0.35'>%1</t>",_disp]};
				case (_sup == 3): {_text = format ["<t color ='#66ff0000' shadow ='0' size='0.35'>%1</t>",_disp]};
				};
			_control ctrlsetposition [(_pos2d select 0) -0.5,(_pos2d select 1)];
			_control ctrlsetstructuredtext parsetext _text;
			_control ctrlsetfade 255;
			_control ctrlcommit 0;
			};
		sleep (1 / _rate);
		};
	};